/**
 * Created with JetBrains WebStorm.
 * User: yuki
 * Date: 13-12-14
 * Time: 上午11:22
 * 标签框样式
 * 使用方法：对取得的jquery对象执行tabBox()方法
 * 2014年8月18日16:10:36 更新
 * 支持传入事件，参数action 默认为click ，备选为hover
 *html格式：
 *
 *
 * <div class="TabBox">
 * <div class="tagMenu">
 * <h2>Title Menu</h2>
 * <ul class="ulMenu">
 * <li>Label 1</li>
 * <li >Label 2</li>
 * <li>Label 3</li>
 * <li>Label 4</li>
 * </ul>
 * </div>
 * <div class="tabContent">
 * <div class="layout">layer 1</div>
 * <div class="layout" style="display:none">layer 2</div>
 * <div class="layout" style="display:none">layer.3</div>
 * <div class="layout" style="display:none">layer 4</div>
 * </div>
 * </div>
 *
 * $("tabBox").tabBox();
  * $("tabBox").tabBox({"action":"hover"});
 */

(function ($) {
    $.fn.extend({
        tabBox: function (options) {
			var defaults ={
				action: "click"
	        };
			var opts = $.extend(defaults, options);
            return this.each(function () {

                var tabBox = $(this);
                var ulbox = tabBox.find(".ulMenu");
                var contentBox = tabBox.children(".tabContent");
                var layout = contentBox.children(".layout");
                var menuli = ulbox.children("li");
                var index = 0;
                var currentIndex = 0;

                var current = ulbox.children(".current");
                if (current.length > 0) {
                    currentIndex = current.index();
                }

                layout.hide();
                layout.eq(currentIndex).show();

                if(opts.action == "click"){
                menuli.click(function () {
                    menuli.removeClass("current");
                    $(this).addClass("current");
                    index = $(this).index();
                    layout.hide();
                    layout.eq(index).show();
                })
				}
				else{
					menuli.hover(function () {
                      menuli.removeClass("current");
                      $(this).addClass("current");
                      index = $(this).index();
                      layout.hide();
                      layout.eq(index).show();
                    },function(){
					  
					})
				}
            });
        }


    })
})(jQuery);
